OUTPUT_ARCH(h8300h)
ENTRY("_start")
MEMORY
{
	vectors 	: o = 0x0000, l = 0x100
	rom(rx)		: o = 0x0100, l = 0x1ff00
	ram(rwx)	: o = 0x00ffc720, l = 0x00000800
	stack(rw)	: o = 0x00ffff0c, l = 0x00000004
/*	ram_sys(rw)	: o = 0x00ffbf20, l = 0x00000800*/
	dram(rwx)	: o = 0x00400000, l = 0x00200000
}
SECTIONS 				
{ 					
.vectors : {
	/* Use something like this to place a specific function's address
	   into the vector table.  */
	LONG(ABSOLUTE(_start))			/*  0 Reset vector */
	LONG(ABSOLUTE(__int_default))		/*    Reserved */
	LONG(ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(DEFINED(int07)?ABSOLUTE(int07):ABSOLUTE(__int_default))
	LONG(DEFINED(int08)?ABSOLUTE(int08):ABSOLUTE(__int_default))
	LONG(DEFINED(int09)?ABSOLUTE(int09):ABSOLUTE(__int_default))

	LONG(DEFINED(int0a)?ABSOLUTE(int0a):ABSOLUTE(__int_default))
	LONG(DEFINED(int0b)?ABSOLUTE(int0b):ABSOLUTE(__int_default))
	LONG(DEFINED(int0c)?ABSOLUTE(int0c):ABSOLUTE(__int_default))
	LONG(DEFINED(int0d)?ABSOLUTE(int0d):ABSOLUTE(__int_default))
	LONG(DEFINED(int0e)?ABSOLUTE(int0e):ABSOLUTE(__int_default))
	LONG(DEFINED(int0f)?ABSOLUTE(int0f):ABSOLUTE(__int_default))
	LONG(DEFINED(int10)?ABSOLUTE(int10):ABSOLUTE(__int_default))
	LONG(DEFINED(int11)?ABSOLUTE(int11):ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))

	LONG(DEFINED(int14)?ABSOLUTE(int14):ABSOLUTE(__int_default))
	LONG(DEFINED(int15)?ABSOLUTE(int15):ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(DEFINED(int17)?ABSOLUTE(int18):ABSOLUTE(__int_default))
	LONG(DEFINED(int18)?ABSOLUTE(int18):ABSOLUTE(__int_default))
	LONG(DEFINED(int19)?ABSOLUTE(int19):ABSOLUTE(__int_default))
	LONG(DEFINED(int1a)?ABSOLUTE(int1a):ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(DEFINED(int1c)?ABSOLUTE(int1c):ABSOLUTE(__int_default))
	LONG(DEFINED(int1d)?ABSOLUTE(int1d):ABSOLUTE(__int_default))

	LONG(DEFINED(int1e)?ABSOLUTE(int1e):ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(DEFINED(int20)?ABSOLUTE(int20):ABSOLUTE(__int_default))
	LONG(DEFINED(int21)?ABSOLUTE(int21):ABSOLUTE(__int_default))
	LONG(DEFINED(int22)?ABSOLUTE(int22):ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(DEFINED(int24)?ABSOLUTE(int24):ABSOLUTE(__int_default))
	LONG(DEFINED(int25)?ABSOLUTE(int25):ABSOLUTE(__int_default))
	LONG(DEFINED(int26)?ABSOLUTE(int26):ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))

	LONG(DEFINED(int28)?ABSOLUTE(int28):ABSOLUTE(__int_default))
	LONG(DEFINED(int29)?ABSOLUTE(int29):ABSOLUTE(__int_default))
	LONG(DEFINED(int2a)?ABSOLUTE(int2a):ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(DEFINED(int2c)?ABSOLUTE(int2c):ABSOLUTE(__int_default))
	LONG(DEFINED(int2d)?ABSOLUTE(int2d):ABSOLUTE(__int_default))
	LONG(DEFINED(int2e)?ABSOLUTE(int2e):ABSOLUTE(__int_default))
	LONG(DEFINED(int2f)?ABSOLUTE(int2f):ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))

	LONG(ABSOLUTE(__int_default))
	LONG(ABSOLUTE(__int_default))
	LONG(DEFINED(int34)?ABSOLUTE(int34):ABSOLUTE(__int_default))
	LONG(DEFINED(int35)?ABSOLUTE(int35):ABSOLUTE(__int_default))
	LONG(DEFINED(int36)?ABSOLUTE(int36):ABSOLUTE(__int_default))
	LONG(DEFINED(int37)?ABSOLUTE(int37):ABSOLUTE(__int_default))
	LONG(DEFINED(int38)?ABSOLUTE(int38):ABSOLUTE(__int_default))
	LONG(DEFINED(int39)?ABSOLUTE(int39):ABSOLUTE(__int_default))
	LONG(DEFINED(int3a)?ABSOLUTE(int3a):ABSOLUTE(__int_default))
	LONG(DEFINED(int3b)?ABSOLUTE(int3b):ABSOLUTE(__int_default))

	LONG(DEFINED(int3c)?ABSOLUTE(int3c):ABSOLUTE(__int_default))

	FILL(0xff)
        }  > vectors
.text : {
        *(.boot)
	*(EXCLUDE_FILE(./aki-h8-3069/drivers/flash_write.o) .text)
	*(.strings)
	*(.rodata*)
	_etext = . ; 
	} > rom
.tors : {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > rom
.data : AT ( ADDR(.tors) + SIZEOF(.tors) ){
	___data = . ;
	./aki-h8-3069/drivers/flash_write.o
	*(.data)
	*(.tiny)
	 _edata = .;
	} > ram
	data_size = SIZEOF(.data);
.bss : {
	 _bss_start = . ;
	*(.bss)
	*(COMMON)
	 _end = . ;  
	}  > ram
	bss_size = SIZEOF(.bss);
.stack : {
	 _stack = . ; 
	}  > stack
.stab 0 (NOLOAD) : {
	[ .stab ]
	}
.stabstr 0 (NOLOAD) : {
	[ .stabstr ]
	}
}
